#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <pthread.h>
#include "gexec_lib.h"
#include "gexecd_options.h"

static int port_ok(int port)
{
    if (port < 1) {
        fprintf(stderr, "-P option (port) must be >= 1\n");
        return 0;
    }
    return 1;
}

void gexecd_options_init(gexecd_options *opts)
{
    opts->inetd = 0;
    opts->port  = GEXEC_DEF_PORT;
}

void gexecd_options_parse(gexecd_options *opts, int argc, char **argv)
{
    int c;
    extern char *optarg;
    static struct option long_options[] =
    {
        { "inetd", no_argument, NULL, 'i' },
        { "port", required_argument, NULL, 'P' },
        { 0, 0, 0, 0 }
    };

    while ((c = getopt_long (argc, argv, "iP:", long_options, 
                             (int *)0)) != EOF) {
        switch (c) {
        case 'i':
            opts->inetd = 1;
            break;
        case 'P':
            opts->port = atoi(optarg);
            if (!port_ok(opts->port))
                exit(0);
            break;
        }
    }
}

void gexecd_options_print(gexecd_options *opts)
{
    printf("gexecd_options:  inetd = %d\n", opts->inetd);
    printf("gexecd_options:  port  = %d\n", opts->port);
}
